
#include <stdio.h>
#include <stdlib.h>
#include "odirect.h"

#define BUFFER_SIZE (1<<20)

int main(int argc, char **argv)
	{
	int fileno;
	int file_descriptor;
	struct odirect_buffer odirect_buffer;

	odirect_aligned_malloc(BUFFER_SIZE, BUFFER_SIZE, &odirect_buffer);
	if (odirect_buffer.aligned_buffer == NULL)
		{
		fprintf(stderr, "Sorry, aligned malloc failed\n");
		exit(1);
		}

	for (fileno=1; fileno<argc; fileno++)
		{
		fprintf(stderr, "Opening %s\n", argv[fileno]);
		file_descriptor = odirect_open(argv[fileno], "r");
		if (file_descriptor < 0)
			{
			fprintf(stderr, "File %s:\n", argv[fileno]);
			perror("Sorry, open failed\n");
			exit(1);
			}

		for (;;)
			{
			struct binary_data binary_data;
			binary_data = odirect_pull(file_descriptor, &odirect_buffer);
			if (binary_data.size == -1)
				{
				perror("odirect_read failed");
				exit(1);
				}
			fprintf(stderr, "Read %d bytes\n", binary_data.size);
			if (binary_data.size == 0)
				{
				break;
				}
			}
		fprintf(stderr, "Closing %s\n", argv[fileno]);
		odirect_close(file_descriptor);
		}
	odirect_aligned_free(&odirect_buffer);
	exit(0);
	}

