
#include <iostream>
#include "odirect-cxx.H"

using namespace std;

#define LEN (1<<19)

main(int argc, char *argv[])
	{
	int argno;
	int total_length=0;
	cout << "C++ test starting" << endl;
	for (argno=1; argno<argc; argno++)
		{
		cout << "Reading file via both odirect and fopen" << argv[argno] << endl;
		odirect foo((const char *)argv[argno], "rbd", LEN);
		FILE *regular_file;
		regular_file = fopen(argv[argno], "rb");
		if (regular_file == NULL)
			{
			cerr << "fopen " << argv[argno] << " failed in cxx-test\n";
			exit(1);
			}
		string s;
		while ((s = foo.pull()) != "")
			{
			char buffer[LEN];
			int length;
			if ((length = fread(buffer, 1, LEN, regular_file)) < 0)
				{
				cerr << "fread " << argv[argno] << " failed in cxx-test\n";
				exit(1);
				}
			if (s.size() != length)
				{
				cerr << "fread and pull got different lengths in cxx-test\n";
				cerr << "s.size() is " << s.size() << endl;
				cerr << "length is " << length << endl;
				exit(1);
				}
			if (memcmp(s.c_str(), buffer, s.size()) != 0)
				{
				cerr << "fread and pull got same lengths, but different content\n";
				exit(1);
				}
			total_length += s.size();
			cout << "Read chunk of size " << s.size() << endl;
			}
		fclose(regular_file);
		}
	/* this is a very, very, very rudimentary test */
	if (total_length == 0)
		{
		cerr << "C++ primitive length test failed!" << endl;
		return 1;
		}
	else
		return 0;
	}

