
#include <iostream>
#include "odirect-cxx.H"

extern "C"
	{
	#include "odirect.h"
	}

odirect::odirect (string filename, string mode, size_t length)
	{
	odirect_filedes = odirect_open((const char *)(filename.c_str()), 
		(const char *)(mode.c_str()));
	odirect_buffer = create_odirect_buffer();
	odirect_aligned_malloc(length, length, odirect_buffer);
	/* cout << "odirect_buffer is " << (int) odirect_buffer << endl; */
	if (odirect_buffer == 0)
		throw;
	/* cout << "odirect_filedes is " << odirect_filedes << endl; */
	}

void odirect::push(string s)
	{
	struct binary_data binary_data;
	binary_data.size = s.size();
	binary_data.data = (char *)(s.c_str());
	odirect_push(odirect_filedes, odirect_buffer, binary_data);
	}

string odirect::pull()
	{
	string s;
	struct binary_data binary_data;
	/* cout << "real_buffer " << (int)odirect_buffer->real_buffer << endl; */
	/* cout << "aligned_buffer " << (int)odirect_buffer->aligned_buffer << endl; */
	binary_data = odirect_pull(odirect_filedes, odirect_buffer);
	/* cout << "In C++ pull binary_data.size is " << binary_data.size << endl; */
	if (binary_data.size == -1)
		{
		throw;
		}
	s.assign(binary_data.data, binary_data.size);
	return s;
	}

odirect::~odirect ()
	{
	odirect_close(odirect_filedes);
	destroy_odirect_buffer(odirect_buffer);
	}

