#!/usr/bin/env python

import os
import sys
sys.path.insert(0, os.path.expanduser('.'))

import odirectcmodule
#print dir(_odirectcmodule)
import sys

class odirect:
	def __init__(self, filename, flags='rbd', length=1<<18):
		self.buffer = odirectcmodule.create_odirect_buffer()
		odirectcmodule.odirect_aligned_malloc(length, length, self.buffer)
		self.file_descriptor = odirectcmodule.odirect_open(filename, 'rd')
		if self.file_descriptor < 0:
			raise OSError

	def push(self, binary_data):
		return odirectcmodule.odirect_push(self.file_descriptor, self.buffer, binary_data)

	def pull(self):
		return odirectcmodule.odirect_pull(self.file_descriptor, self.buffer)

	def __del__(self):
		odirectcmodule.odirect_close(self.file_descriptor)
		odirectcmodule.odirect_aligned_free(self.buffer)
		odirectcmodule.destroy_odirect_buffer(self.buffer)

	close = __del__

